
<p>Digitalni sustavi danas su posvuda oko nas. Bilo da se radi o računalu, mobitelu, kalkulatoru, digitalnom satu, modernom TV-prijemniku, tabletu, prijenosnom računalu ili nečemu sasvim desetome, princip rada ovih uređaja je isti. Oni svi primaju, pohranjuju, obrađuju i prikazuju informacije.</p>

<p>Minimalna razlučiva jedinica informacije u digitalnom sustavu je <em>bit</em> <span class="language-english"><span>bit</span></span>. Digitalni sustav informacije čuva u memoriji. Memorija je digitalni podsustav koji čuva grupe bitova na memorijskim lokacijama. Minimalna grupa bitova s kojom se danas tipično radi je grupa od osam bitova. Takvu grupu nazivamo <em>oktet</em> <span class="language-english"><span>byte</span></span>.</p>

<p>Ako znamo da u memoriji računala na određenoj memorijskoj lokaciji imamo zapisanu određenu grupu bitova, možemo li zaključiti što taj zapisani sadržaj <em>znači</em>? Primjerice, što predstavlja sljedeća grupa bitova: <span class="lang-constant">01000001</span>? Odgovor na to pitanje nije jednoznačan: ti bitovi dobivaju određeno značenje tek kada je zadan kontekst u okviru kojeg se isti interpretiraju. No što to znači?
</p>

<p>Evo nekoliko različitih kontekstova i pridijeljenog značenja razmatrane grupe bitova.</p>

<ul>
<li><div class="li-definition">Kontekst: prirodni binarni kod.</div>
    Podatak predstavlja cijeli broj čija je vrijednost 65.</li>
<li><div class="li-definition">Kontekst: ASCII kod.</div>
    Podatak predstavlja slovo; konkretno, radi se o velikom slovu 'A'.</li>
<li><div class="li-definition">Kontekst: prikaz dekadskih brojeva.</div>
    Podatak predstavlja dekadski broj 41 u pakiranom kodu BCD.</li>
<li><div class="li-definition">Kontekst: zaštita paritetnim bitom.</div>
    Podatak predstavlja kodnu riječ dobivenu zaštitom 7-bitne grupe bitova <span class="lang-constant">1000001</span> paritetnim bitom uporabom parnog pariteta.</li>
<li><div class="li-definition">Kontekst: instrukcija procesora.</div>
    Podatak predstavlja procesorsku instrukciju <span class="lang-constant">INC AX</span> koja će sadržaj podatkovnog registra AX uvećati za jedan (i rezultat vratiti natrag u taj registar).</li>
</ul>

<p>Uz prikazane, moguć je još niz drugih različitih interpretacija. Ako Vam u ovom trenutku nije jasno kako smo došli do svake od prikazanih interpretacija, nije važno - upoznat ćemo se s time detaljnije u nastavku.</p>

<p>Veće grupe bitova mogu imati još više različitih interpretacija. Primjerice, grupe od 32-bita moguće je interpretirati kao:</p>
<ul>
<li>cijele brojeve koji mogu poprimiti vrijednosti iz intervala 0 do 4294967295 (tj. poprilici do 4,3 milijarde) ako grupu promatramo kao prirodni binarni kod bez predznaka,</li>
<li>cijele brojeve koji mogu poprimiti vrijednosti iz intervala -2147483648 do 2147483647 ako grupu promatramo kao prirodni binarni kod s predznakom u zapisu 2-komplementa,</li>
<li>dekadske brojeve koji mogu poprimiti vrijednosti iz intervala 0 do 99999999 ako grupu promatramo kao pakirani kod BCD,</li>
<li>decimalne brojeve gdje je najmanja magnituda broja je 2<sup>-149</sup> ≈ 1.4 × 10<sup>-45</sup> a najveća magnituda broja (1-2<sup>-24</sup>) × 2<sup>128</sup> ≈ 3.4 × 10<sup>38</sup>, ako interpretiramo u skladu sa specifikacijom <a href="https://en.wikipedia.org/wiki/IEEE_floating_point" target="_blank">IEEE 754</a> (detaljnije o <a href="https://en.wikipedia.org/wiki/Single-precision_floating-point_format" target="_blank">zapisu koji koristi 32-bita</a>).</li>
<li>...</li>
</ul>

<p>Programski jezici programeru nude mogućnost definiranja načina interpretacije niza bitova uporabom <em>tipova podataka</em>. Evo jednostavnog primjera programa u programskom jeziku C koji će to ilustrirati. Ako u ovom trenutku ne znate dovoljno programskog jezika C, primjer pogledajte samo informativno; detalje slobodno preskočite.</p>

<pre><code>#include&lt;stdio.h&gt;
#include&lt;stdlib.h&gt;

void ispisi(void *f) {
  unsigned char n = *((unsigned char*)f);
  unsigned char maska = 0b10000000;
  int i;
  for(i=0; i&lt;=7; i++) {
    printf("%d", (n&amp;maska)==maska ? 1 : 0);
    maska = maska &gt;&gt; 1;
  }
}

void ispisi_varijablu(char *ime, void *f) {
  printf("%s = ", ime); ispisi(f); printf("\n");
}

int main() {
  char a=64, b=65, c;
  unsigned char d=64, e=65, f;
  char g='A';

  c = a-b;
  f = d-e;

  ispisi_varijablu("a", &amp;a);
  ispisi_varijablu("b", &amp;b);
  ispisi_varijablu("c", &amp;c);
  ispisi_varijablu("d", &amp;d);
  ispisi_varijablu("e", &amp;e);
  ispisi_varijablu("f", &amp;f);
  ispisi_varijablu("g", &amp;g);

  if(c &lt; 0) {
    printf("c je manji od nule.\n");
  } else {
    printf("c je veći od nule.\n");
  }

  if(f &lt; 0) {
    printf("f je manji od nule.\n");
  } else {
    printf("f je veći od nule.\n");
  }
}</code></pre>

<p>Program možete pohraniti u datoteku <span class="filename">program.c</span>, prevesti iz naredbenog retka (uz pretpostavku da ste instalirali <span class="command">gcc</span>):</p>

<pre><samp class="command-line">gcc program.c</samp></pre>

<p>i potom pokrenuti. Na operacijskom sustavu Windows naredba bi bila:</p>

<pre><samp class="command-line">.\a.exe</samp></pre>

<p>a na operacijskom sustavu Linux:</p>

<pre><samp class="command-line">./a.out</samp></pre>

<p>Pokretanjem će se dobiti ispis prikazan u nastavku.</p>

<pre><samp class="program-output">a = 01000000
b = 01000001
c = 11111111
d = 01000000
e = 01000001
f = 11111111
g = 01000001
c je manji od nule.
f je veći od nule.
</samp></pre>

<p>Program definira ukupno 7 varijabli. Svaka od tih 7 varijabli bit će smještena na jednu memorijsku lokaciju i zauzimat će točno 8 bitova. Varijable <var>a</var> i <var>b</var> inicijaliziramo tako da u njih pohranjujemo brojeve 64 i 65. Iste vrijednosti zapisujemo i u varijable <var>d</var> i <var>e</var>. Kako je svaki od pripadnih 8 bitova postavljen u memoriji gdje se čuva sadržaj ovih varijabli, pogledajte u prethodnom ispisu.</p>

<p>Program u varijablu <var>c</var> sprema rezultat oduzimanja <var>b</var> od <var>a</var>, a u varijablu <var>f</var> sprema rezultat oduzimanja <var>e</var> od <var>d</var>. Bitovni sadržaj koji je pohranjen u memoriju za obje je varijable isti: i <var>c</var> i <var>f</var> u memoriji imaju zapisan bitovni sadržaj <span class="lang-constant">11111111</span>.</p>

<p>Ono što je posebno interesantno, nalazi se na samom kraju programa. Ispituje se je li sadržaj varijabli <var>c</var> i <var>f</var> negativan ili nije, i ispisuje se prikladna poruka. Pogledajte kakav je bio ispis.</p>

<p>Bitovni sadržaj obje varijable u memoriji je identičan. Ipak, prvo ispitivanje utvrđuje da je sadržaj varijable <var>c</var> negativan i to ispisuje dok drugo ispitivanje utvrđuje da sadržaj varijable <var>f</var> nije negativan i to ispisuje. Da bismo razumjeli zašto, sada moramo vidjeti koji je kontekst u kojem se interpretira binarni uzorak <span class="lang-constant">11111111</span> u ta dva slučaja.</p>

<p>U prvom slučaju, tip varijable koja se koristi u ispitivanju je <span class="lang-type">char</span>. Stoga se bitovni uzorak <span class="lang-constant">11111111</span> tumači kao cijeli broj s predznakom zapisan uporabom 2-komplementa. Uz takvu interpretaciju (naučit ćemo kako se to radi), radi se o cijelom broju čija je vrijednost -1. I time postaje jasno zašto je prvo ispitivanje ispisalo da se radi o negativnom broju.</p>

<p>U drugom slučaju, tip varijable koja se koristi u ispitivanju je <span class="lang-type">unsigned char</span>. Stoga se bitovni uzorak <span class="lang-constant">11111111</span> tumači kao cijeli broj zapisan prirodnim binarnim kodom (bez predznaka). Uz takvu interpretaciju (naučit ćemo kako se to radi), radi se o cijelom broju čija je vrijednost 255 čime postaje jasan i rezultat drugog ispitivanja.</p>

